package nl.naturalis.bcd.migrate;

import java.sql.Connection;
import java.sql.SQLException;
import org.klojang.db.KJSQLException;
import org.klojang.db.SQL;
import org.klojang.db.SQLInsert;
import org.klojang.db.SQLQuery;
import org.klojang.util.namemappers.CamelCaseToSnakeLowerCase;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import nl.naturalis.bcd.json.BcdModule;

abstract class AbstractMigrator<SOURCE extends SelfTransformer<TARGET>, TARGET> {

  private static final Logger LOG = LoggerFactory.getLogger(AbstractMigrator.class);

  private final Connection srcCon;
  private final Connection trgCon;
  private final Class<SOURCE> srcClass;
  private final Class<TARGET> trgClass;

  private int processed;
  private int inserted;
  private int rejected;
  private int skipped;

  AbstractMigrator(
      Connection srcCon, Connection trgCon, Class<SOURCE> srcClass, Class<TARGET> trgClass) {
    this.srcCon = srcCon;
    this.trgCon = trgCon;
    this.srcClass = srcClass;
    this.trgClass = trgClass;
  }

  void run() {
    LOG.info("Begin nu aan tabel {} ...", targetTable());
    LOG.info("Bron tabel: {} ", sourceTable());
    try {
      trgCon.setAutoCommit(true);
      trgCon.createStatement().execute("TRUNCATE TABLE " + targetTable());
    } catch (SQLException e) {
      LOG.error(e.getMessage());
      return;
    }
    afterTruncate(srcCon, trgCon);
    SQL sql = SQL.create(getExtactSQL());
    SQLInsert insert = getInsertStatement(trgCon);
    try (SQLQuery query = sql.prepareQuery(srcCon).withMapper(new SelectMapper())) {
      TARGET targetBean;
      for (SOURCE sourceBean : query.getBeanifier(srcClass)) {
        targetBean = null;
        ++processed;
        try {
          if (!beforeTransform(sourceBean)) {
            ++skipped;
          } else {
            targetBean = sourceBean.morph();
            if (beforeInsert(sourceBean, targetBean, srcCon, trgCon)) {
              insert.bind(targetBean);
              int id = (int) insert.executeAndGetId();
              afterInsert(sourceBean, targetBean, id);
              ++inserted;
            } else {
              ++skipped;
            }
          }
        } catch (MigrationException e) {
          ++rejected;
          LOG.error(e.getMessage());
        } catch (AbortException e) {
          throw e;
        } catch (KJSQLException e) {
          ++rejected;
          LOG.error(e.getMessage());
          if (targetBean != null) {
            LOG.error(
                "While trying to insert this record:\n{}", BcdModule.writePrettyJson(targetBean));
          }
        } catch (Exception e) {
          throw new AbortException(e);
        }
      }
    }
    LOG.info("Verwerkte rijen ......: {}", processed);
    LOG.info("Database inserts .....: {}", inserted);
    LOG.info("Afgewezen rijen ......: {}", rejected);
    LOG.info("Overgeslagen rijen ...: {}", skipped);
    aferMainStatistics(srcCon, trgCon);
    LOG.info("****************************************************************************");
  }

  abstract String sourceTable();

  String targetTable() {
    return "bcd_" + new CamelCaseToSnakeLowerCase().map(trgClass.getSimpleName());
  }

  String idProperty() {
    return targetTable().substring(4) + "Id";
  }

  String getExtactSQL() {
    return "SELECT * FROM " + sourceTable();
  }

  SQLInsert getInsertStatement(Connection trgCon) {
    return SQL.prepareInsert()
        .of(trgClass)
        .into(targetTable())
        .excluding(idProperty())
        .prepare(trgCon);
  }

  /** Callback, just after target table has been truncated, but before anything else. */
  @SuppressWarnings("unused")
  void afterTruncate(Connection srcCon, Connection trgCon) {
    // ...
  }

  /**
   * Callback, after source bean has been created and just before its transformation into a BCD
   * model object. When returning false, the model object will not be created and we skip to the
   * next record.
   */
  @SuppressWarnings("unused")
  boolean beforeTransform(SOURCE src) throws MigrationException {
    return true;
  }

  /**
   * Callback, after both source bean and model object have been created and just before saving the
   * latter to the database. When returning false, the model object will not be inserted and we skip
   * to the next record.
   */
  @SuppressWarnings("unused")
  boolean beforeInsert(SOURCE src, TARGET trg, Connection srcCon, Connection trgCon)
      throws MigrationException {
    return true;
  }

  /** Callback, just after the database insert, when an ID has been generated by the database. */
  @SuppressWarnings("unused")
  void afterInsert(SOURCE src, TARGET trg, int id) throws MigrationException {
    // ...
  }

  /** Callback, just after main statistics have been printed. */
  @SuppressWarnings("unused")
  void aferMainStatistics(Connection srcCon, Connection trgCon) {
    // ...
  }
}
